=== debian/changelog ===
ros-noetic-quanergy-client (5.0.0-1buster) buster; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Ross Taylor <ross.taylor@quanergy.com>  Wed, 14 Jul 2021 00:16:31 -0000
