=== debian/control ===
Source: ros-noetic-quanergy-client
Section: misc
Priority: optional
Maintainer: Ross Taylor <ross.taylor@quanergy.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libpcl-dev
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-quanergy-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libpcl-dev, ros-noetic-catkin
Description: Quanergy Sensor SDK
